#ifndef QRK_DETECT_OS_H
#define QRK_DETECT_OS_H

/*!
  \file
  \brief 動作OSの検出

  \author Satofumi KAMIMURA

  $Id: DetectOS.h 1073 2009-06-25 22:05:22Z satofumi $
*/

#if defined _MSC_VER || defined __CYGWIN__ || defined __MINGW32__
#define WINDOWS_OS

#if defined _MSC_VER
#define MSC
#ifndef _CRT_SECURE_NO_WARNINGS
#define _CRT_SECURE_NO_WARNINGS
#endif
#ifndef _D_SCL_SECURE_NO_WARNINGS
#define _D_SCL_SECURE_NO_WARNINGS
#endif
#ifndef _CRT_SECURE_NO_DEPRECDATE
#define _CRT_SECURE_NO_DEPRECDATE
#endif
#elif defined __CYGWIN__
#define Cygwin
#elif defined __MINGW32__
#define MinGW
#endif

#elif defined __linux__
#define LINUX_OS

#else
// 検出できないときを、Mac 扱いにしてしまう
#define MAC_OS
#endif

#endif /* !QRK_DETECT_OS_H */
